﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace LogCombiner
{
    class LogFile
    {
        public LogFile(string filename)
        {
            Filename = filename;
        }

        string fileName = string.Empty;
        public string Filename
        {
            get
            {
                return fileName;
            }
            set
            {
                if (tr != null) tr.Close();
                fileName = value;
                tr = new StreamReader(fileName);
                ReadLine();
            }
        }

        public bool EOF
        {
            get;
            set;
        }

        TextReader tr;
        public TextReader TR
        {
            get
            {
                return tr;
            }
        }

        public string CurrentLine
        {
            get;
            set;
        }

        public DateTime CurrentTimeStamp
        {
            get
            {
                DateTime timestamp = DateTime.MaxValue;
                if (!EOF)
                {
                    // no date or not parsing = error
                    if (CurrentLine.Length > 23)
                    {
                        timestamp = DateTime.Parse(CurrentLine.Substring(0, 23));
                    }
                    else
                    {
                        EOF = true;
                    }
                }
                return timestamp;
            }
        }

        public void ReadLine()
        {
            if (tr != null)
            {
                CurrentLine = tr.ReadLine();
            }
            if ((CurrentLine == String.Empty) && !EOF) ReadLine();
            if (CurrentLine == null)
            {
                tr.Close();
                EOF = true;
                tr = null;
            }
        }
    }
}
